/*=====================================================================+
|======================    splitallGFX    =============================|
+======================================================================+
|  Graphical front-end for 'splitall' (v0.7.1) by Auriemma Luigi:      |
|  <aluigi@pivx.com>, http://aluigi.altervista.org/                    |
|                                                                      |
|  Author: Marco Segato <segatom@yahoo.it> aka Mach <tumin17@yahoo.it> |
|  Version: look at 'final String VERSION' at line 41                  |
|  Website: http://www.marcosegato.tk                                  |
|  This program is released under GNU GPL license, http://www.gnu.org  |
+---------------------------------------------------------------------*/

import java.awt.Color;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.File;
import java.io.IOException;
import java.lang.Runtime;
import javax.swing.border.*;
import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JTextField;

public class splitallGFX
{ public static void main (String[]args)
	{ final String VERSION = "0.1.1";			// PROGRAM VERSION
	MyFrame frame = new MyFrame();				// principale frame
	frame.setTitle("splitallGFX v"+VERSION);		// frame's title

	Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize(); // frame's position
	Dimension frameSize = frame.getSize();
	if (frameSize.height > screenSize.height)
		{ frameSize.height = screenSize.height;
		}
	if (frameSize.width > screenSize.width)
		{ frameSize.width = screenSize.width;
		}
	frame.setLocation((screenSize.width - frameSize.width)/2, (screenSize.height - frameSize.height)/2);
	frame.show();						// show frame
	}
}

class MyFrame extends JFrame					// principale frame
{ public MyFrame()
	{ final int DEFAULT_FRAME_WIDTH = 400;
	final int DEFAULT_FRAME_HEIGHT = 470;
	setSize(DEFAULT_FRAME_WIDTH, DEFAULT_FRAME_HEIGHT);

	MenuListener mListener = new MenuListener();
	ActionListener listener = new ButtonAction();
	ChoiceListener cListener = new ChoiceListener();
	addWindowListener(new WindowCloser());

	JMenuBar menuBar = new JMenuBar();			// menu bar
	setJMenuBar(menuBar);
	JMenu helpMenu = new JMenu("Help");
	JMenu exitMenu = new JMenu("Exit");
	menuBar.add(helpMenu);
	menuBar.add(exitMenu);
	aboutMenuItem = new JMenuItem("SplitallGFX About");
	aboutMenuItem.addActionListener(mListener);
	helpMenu.add(aboutMenuItem);
	exitMenuItem = new JMenuItem("Exit SplitallGFX");
	exitMenuItem.addActionListener(mListener);
	exitMenu.add(exitMenuItem);

	/**/JPanel inFilePanel = new JPanel();		// in(sertion) panel
	inFilePanel.setLayout(new GridLayout(4,1));
	inButton = new JButton("Open the file to SPLIT");
	inButton.setVisible(false);
	inButton.addActionListener(listener);
	inTextField = new JTextField(35);
	inTextField.setEditable(false);
	inTextField.setHorizontalAlignment(0);
	/***/JPanel inModePanel = new JPanel();
	ButtonGroup modeGroup = new ButtonGroup();
	splitButton = new JRadioButton("Split");
	splitButton.addActionListener(cListener);
	desplitButton = new JRadioButton("Desplit");
	desplitButton.addActionListener(cListener);
	modeGroup.add(splitButton);
	modeGroup.add(desplitButton);
	/***/inModePanel.add(splitButton);
	inModePanel.add(desplitButton);
	/*#*/sizePanel = new JPanel();
	sizePanel.setVisible(false);
	dialogTextField = new JTextField(20);
	dialogLabel = new JLabel();
	/*#*/sizePanel.add(dialogLabel);
	sizePanel.add(dialogTextField);
	/**/inFilePanel.add(inButton);
	inFilePanel.add(inTextField);
	inFilePanel.add(inModePanel);
	inFilePanel.add(sizePanel);

	/**/JPanel typePanel = new JPanel();			// splitting/desplitting type panel
	typePanel.setLayout(new GridLayout(7,2));
	typePanel.setBorder(new TitledBorder(new BevelBorder(BevelBorder.RAISED,Color.lightGray,Color.white,new Color(124, 124, 124),new Color(178, 178, 178)), ""));
	ButtonGroup typeGroup = new ButtonGroup();
	O_Button = new JRadioButton("0 = Linux split");
	O_Button.addActionListener(cListener);
	I_Button = new JRadioButton("1 = SplitALL");
	I_Button.addActionListener(cListener);
	II_Button = new JRadioButton("2 = SplitFile");
	II_Button.addActionListener(cListener);
	III_Button = new JRadioButton("3 = Splitit!");
	III_Button.addActionListener(cListener);
	IV_Button = new JRadioButton("4 = Splitter");
	IV_Button.addActionListener(cListener);
	V_Button = new JRadioButton("5 = MaxSplitter");
	V_Button.addActionListener(cListener);
	VI_Button = new JRadioButton("6 = Spezzatutto");
	VI_Button.addActionListener(cListener);
	typeGroup.add(O_Button);
	typeGroup.add(I_Button);
	typeGroup.add(II_Button);
	typeGroup.add(III_Button);
	typeGroup.add(IV_Button);
	typeGroup.add(V_Button);
	typeGroup.add(VI_Button);
	/**/typePanel.add(O_Button); typePanel.add(new JLabel("es: xaa"));
	typePanel.add(I_Button); typePanel.add(new JLabel("es: xaa.txt"));
	typePanel.add(II_Button); typePanel.add(new JLabel("es: filename.000 [+ header]"));
	typePanel.add(III_Button); typePanel.add(new JLabel("es: filenameext.0"));
	typePanel.add(IV_Button); typePanel.add(new JLabel("es: filename_00.exe [+ .ssp]"));
	typePanel.add(V_Button); typePanel.add(new JLabel("es: filename.ext.001 [+ MXS]"));
	typePanel.add(VI_Button); typePanel.add(new JLabel("es: filename.aa"));

	/**/JPanel splitPanel = new JPanel();			// do-splitting/desplitting panel
	splitPanel.setLayout(new GridLayout(2,1));
	goSplitallButton = new JButton("Go !");
	goSplitallButton.addActionListener(listener);
	lineCommandTextField = new JTextField(35);
	lineCommandTextField.setEditable(false);
	lineCommandTextField.setBackground(Color.white);
	/**/splitPanel.add(lineCommandTextField);
	splitPanel.add(goSplitallButton);

	JPanel northPanel = new JPanel();			// grouping panels
	northPanel.add(inFilePanel);
	JPanel centerPanel = new JPanel();
	centerPanel.add(typePanel);
	JPanel southPanel = new JPanel();
	southPanel.add(splitPanel);

	Container contentPane = getContentPane();		// panels' disposition on the frame
	contentPane.add(northPanel, "North");
	contentPane.add(centerPanel, "Center");
	contentPane.add(southPanel, "South");
	}

	public void runSplitall(String arg)			// running splitall
	{ String log = "";
	Runtime r = java.lang.Runtime.getRuntime();
	try
		{ while (log.equals("") == true)
			{ Process p = r.exec(arg);
			java.io.BufferedReader in = new java.io.BufferedReader(new java.io.InputStreamReader(p.getInputStream()),4048);
			p.waitFor();
			while (in.ready())
        			log = log + in.readLine() + "\n";
			}
		JOptionPane.showMessageDialog(null, log);
		}
        catch (InterruptedException e)
        	{ JOptionPane.showMessageDialog(null, "Error on exec method call.");
        	}
	catch (IOException e)
		{ JOptionPane.showMessageDialog(null, "Error on exec method call.");
		}
	}

	private JPanel sizePanel;				// panels
	private JButton inButton;				// buttons
	private JButton goSplitallButton;
	private JMenuItem aboutMenuItem;			// menu items
	private JMenuItem exitMenuItem;
	private JRadioButton splitButton;			// radio buttons
	private JRadioButton desplitButton;
	private JRadioButton O_Button;
	private JRadioButton I_Button;
	private JRadioButton II_Button;
	private JRadioButton III_Button;
	private JRadioButton IV_Button;
	private JRadioButton V_Button;
	private JRadioButton VI_Button;
	private JTextField inTextField;			// text fields
	private JTextField dialogTextField;
	private JTextField lineCommandTextField;
	private JLabel dialogLabel;
	private final String VERSION = "0.1.1";		// constants
	private final String OS_RUN = "splitall";

	private class MenuListener implements ActionListener	// interception of menu events
	{ public void actionPerformed(ActionEvent mEvent)
		{ Object mSource = mEvent.getSource();
		if (mSource == aboutMenuItem)
			{ JOptionPane.showMessageDialog(null, "Graphical front-end for 'splitALL' (v0.7.1) by Auriemma Luigi"+
								"\n<aluigi@pivx.com>, http://aluigi.altervista.org/"+
								"\n\nAuthor: Marco Segato <segatom@yahoo.it> aka Mach <tumin17@yahoo.it>"+
								"\nVersion: "+VERSION+
								"\nWebsite:  http://www.marcosegato.tk"+
								"\n\nThis program is released under GNU GPL license, http://www.gnu.org");
			}
		else if (mSource == exitMenuItem)
			System.exit(0);
		}
	}

	private class ButtonAction implements ActionListener	// interception of button events
	{ public void actionPerformed(ActionEvent event)
		{ Object source = event.getSource();
		if (source == inButton)
			{ try
				{ JFileChooser chooser = new JFileChooser();
				if (chooser.showOpenDialog(null) == JFileChooser.APPROVE_OPTION)
					{ File selectedFile = chooser.getSelectedFile();
					inTextField.setText(selectedFile.toString());
					}
				}
			catch (NullPointerException e)
				{ JOptionPane.showMessageDialog(null, "Error on file reading.");
				}
			}
		if (source == goSplitallButton)
			{ String fileName = inTextField.getText().trim();
			String dialogSplitting = dialogTextField.getText().trim();
			String optionSplit = "";
			if (splitButton.isSelected())
				optionSplit = " -s ";
			if (desplitButton.isSelected())
				optionSplit = " -d ";
			int noErr = 0;
			try
				{ if (splitButton.isSelected())	// rewriting full command-line for splitting
					{ if (O_Button.isSelected())
						{ if (lineCommandTextField.getText().trim().equals("") == false)
							lineCommandTextField.setText(OS_RUN+optionSplit+dialogSplitting+" -m 0 "+fileName);
						}
					if (I_Button.isSelected())
						{ if (lineCommandTextField.getText().trim().equals("") == false)
							lineCommandTextField.setText(OS_RUN+optionSplit+dialogSplitting+" -m 1 "+fileName);
						}
					if (II_Button.isSelected())
						{ if (lineCommandTextField.getText().trim().equals("") == false)
							lineCommandTextField.setText(OS_RUN+optionSplit+dialogSplitting+" -m 2 "+fileName);
						}
					if (III_Button.isSelected())
						{ if (lineCommandTextField.getText().trim().equals("") == false)
							lineCommandTextField.setText(OS_RUN+optionSplit+dialogSplitting+" -m 3 "+fileName);
						}
					if (IV_Button.isSelected())
						{ if (lineCommandTextField.getText().trim().equals("") == false)
							lineCommandTextField.setText(OS_RUN+optionSplit+dialogSplitting+" -m 4 "+fileName);
						}
					if (V_Button.isSelected())
						{ if (lineCommandTextField.getText().trim().equals("") == false)
							lineCommandTextField.setText(OS_RUN+optionSplit+dialogSplitting+" -m 5 "+fileName);
						}
					if (VI_Button.isSelected())
						{ if (lineCommandTextField.getText().trim().equals("") == false)
							lineCommandTextField.setText(OS_RUN+optionSplit+dialogSplitting+" -m 6 "+fileName);
						}
					}
				if (desplitButton.isSelected())	// rewriting full command-line for desplitting
					{ if (O_Button.isSelected())
						{ if (lineCommandTextField.getText().trim().equals("") == false)
							lineCommandTextField.setText(OS_RUN+optionSplit+"-m 0 "+dialogSplitting);
						}
					if (I_Button.isSelected())
						{ if (lineCommandTextField.getText().trim().equals("") == false)
							lineCommandTextField.setText(OS_RUN+optionSplit+"-m 1 "+dialogSplitting);
						}
					if (II_Button.isSelected())
						{ if (lineCommandTextField.getText().trim().equals("") == false)
							lineCommandTextField.setText(OS_RUN+optionSplit+"-m 2 "+dialogSplitting);
						}
					if (III_Button.isSelected())
						{ if (lineCommandTextField.getText().trim().equals("") == false)
							lineCommandTextField.setText(OS_RUN+optionSplit+"-m 3 "+dialogSplitting);
						}
					if (IV_Button.isSelected())
						{ if (lineCommandTextField.getText().trim().equals("") == false)
							lineCommandTextField.setText(OS_RUN+optionSplit+"-m 4 "+dialogSplitting);
						}
					if (V_Button.isSelected())
						{ if (lineCommandTextField.getText().trim().equals("") == false)
							lineCommandTextField.setText(OS_RUN+optionSplit+"-m 5 "+dialogSplitting);
						}
					if (VI_Button.isSelected())
						{ if (lineCommandTextField.getText().trim().equals("") == false)
							lineCommandTextField.setText(OS_RUN+optionSplit+"-m 6 "+dialogSplitting);
						}
					}
				if (splitButton.isSelected() && inTextField.getText().trim().equals(""))	// eventual errors
					{ JOptionPane.showMessageDialog(null, "Open the file to split!");
					noErr = 1;
					}
				if (splitButton.isSelected() && dialogTextField.getText().trim().equals(""))
					{ JOptionPane.showMessageDialog(null, "Insert splitting-size!");
					noErr = 1;
					}
				if (splitButton.isSelected() && O_Button.isSelected() == false
							&& I_Button.isSelected() == false && II_Button.isSelected() == false
							&& III_Button.isSelected() == false && IV_Button.isSelected() == false
							&& V_Button.isSelected() == false && VI_Button.isSelected() == false)
					{ JOptionPane.showMessageDialog(null, "Choose the method of the splitting!");
					noErr = 1;
					}
				if (desplitButton.isSelected() && O_Button.isSelected() == false
							&& I_Button.isSelected() == false && II_Button.isSelected() == false
							&& III_Button.isSelected() == false && IV_Button.isSelected() == false
							&& V_Button.isSelected() == false && VI_Button.isSelected() == false)
					{ JOptionPane.showMessageDialog(null, "Choose the method of the desplitting!");
					noErr = 1;
					}
				if (desplitButton.isSelected() && (O_Button.isSelected() || I_Button.isSelected()) && dialogTextField.getText().equals(""))
					{ JOptionPane.showMessageDialog(null, "Insert the name of the file to obtain!");
					noErr = 1;
					}
				if (desplitButton.isSelected() && (II_Button.isSelected() || III_Button.isSelected()
							|| IV_Button.isSelected() || V_Button.isSelected() || VI_Button.isSelected())
							&& dialogTextField.getText().trim().equals(""))
					{ JOptionPane.showMessageDialog(null, "Insert the name of the first file of the splitting-sequence");
					noErr = 1;
					}
				if (noErr != 1)
					{ runSplitall(lineCommandTextField.getText());
					JOptionPane.showMessageDialog(null, "INFO: File/s created in splitall's folder.");
					}
				}
			catch (IndexOutOfBoundsException e)
				{ JOptionPane.showMessageDialog(null, "Choose if you want to split or desplit files!");
				}
			}
		}
	}

	private class ChoiceListener implements ActionListener	// interception of radio-button events
	{ public void actionPerformed(ActionEvent cEvent)
		{ String fileName = inTextField.getText().trim();
		String dialogSplitting = dialogTextField.getText().trim();
		if (splitButton.isSelected())
			{ inButton.setVisible(true);
			inTextField.setVisible(true);
			inTextField.setEditable(true);
			if (inTextField.getText().endsWith("!"))
				{ inTextField.setText("");
				fileName = "";
				}
			if (inTextField.getText().equals("") || dialogTextField.getText().equals(""))
				JOptionPane.showMessageDialog(null, "Choose the file to split and/or insert the splitting-size (bytes)");
			lineCommandTextField.setText(OS_RUN+" -s ");
			dialogLabel.setText("Splitting-size (BYTES): ");
			sizePanel.setVisible(true);
			if (O_Button.isSelected())
				{ if (lineCommandTextField.getText().trim().equals("") == false)
					lineCommandTextField.setText(lineCommandTextField.getText()+dialogSplitting+" -m 0 "+fileName);
				}
			if (I_Button.isSelected())
				{ if (lineCommandTextField.getText().trim().equals("") == false)
					lineCommandTextField.setText(lineCommandTextField.getText()+dialogSplitting+" -m 1 "+fileName);
				}
			if (II_Button.isSelected())
				{ if (lineCommandTextField.getText().trim().equals("") == false)
					lineCommandTextField.setText(lineCommandTextField.getText()+dialogSplitting+" -m 2 "+fileName);
				}
			if (III_Button.isSelected())
				{ if (lineCommandTextField.getText().trim().equals("") == false)
					lineCommandTextField.setText(lineCommandTextField.getText()+dialogSplitting+" -m 3 "+fileName);
				}
			if (IV_Button.isSelected())
				{ if (lineCommandTextField.getText().trim().equals("") == false)
					lineCommandTextField.setText(lineCommandTextField.getText()+dialogSplitting+" -m 4 "+fileName);
				}
			if (V_Button.isSelected())
				{ if (lineCommandTextField.getText().trim().equals("") == false)
					lineCommandTextField.setText(lineCommandTextField.getText()+dialogSplitting+" -m 5 "+fileName);
				}
			if (VI_Button.isSelected())
				{ if (lineCommandTextField.getText().trim().equals("") == false)
					lineCommandTextField.setText(lineCommandTextField.getText()+dialogSplitting+" -m 6 "+fileName);
				}
			}
		if (desplitButton.isSelected())
			{ inButton.setVisible(false);
			inTextField.setVisible(true);
			inTextField.setEditable(false);
			sizePanel.setVisible(false);
			lineCommandTextField.setText(OS_RUN+" -d ");
			if (O_Button.isSelected())
				{ inTextField.setText("IMPORTANT: files to desplit MUST be in the SAME PATH of splitall!");
				dialogLabel.setText("File to obtain ");
				sizePanel.setVisible(true);
				if (dialogTextField.getText().trim().equals(""))
					JOptionPane.showMessageDialog(null, "Insert the name of the file to obtain");
				if (lineCommandTextField.getText().equals("") == false)
					lineCommandTextField.setText(lineCommandTextField.getText()+"-m 0 "+" "+dialogSplitting);
				}
			if (I_Button.isSelected())
				{ inTextField.setText("IMPORTANT: files to desplit MUST be in the SAME PATH of splitall!");
				dialogLabel.setText("File to obtain ");
				sizePanel.setVisible(true);
				if (dialogTextField.getText().trim().equals(""))
					JOptionPane.showMessageDialog(null, "Insert the name of the file to obtain");
				if (lineCommandTextField.getText().equals("") == false)
					lineCommandTextField.setText(lineCommandTextField.getText()+"-m 1 "+" "+dialogSplitting);
				}
			if (II_Button.isSelected())
				{ inTextField.setText("IMPORTANT: files to desplit MUST be in the SAME PATH of splitall!");
				dialogLabel.setText("First file of sequence ");
				sizePanel.setVisible(true);
				if (dialogTextField.getText().trim().equals(""))
					JOptionPane.showMessageDialog(null, "Insert the name of the first file of the splitting-sequence");
				if (lineCommandTextField.getText().equals("") == false)
					lineCommandTextField.setText(lineCommandTextField.getText()+"-m 2 "+" "+dialogSplitting);
				}
			if (III_Button.isSelected())
				{ inTextField.setText("IMPORTANT: files to desplit MUST be in the SAME PATH of splitall!");
				dialogLabel.setText("First file of sequence ");
				sizePanel.setVisible(true);
				if (dialogTextField.getText().trim().equals(""))
					JOptionPane.showMessageDialog(null, "Insert the name of the first file of the splitting-sequence");
				if (lineCommandTextField.getText().equals("") == false)
					lineCommandTextField.setText(lineCommandTextField.getText()+"-m 3 "+" "+dialogSplitting);
				}
			if (IV_Button.isSelected())
				{ inTextField.setText("IMPORTANT: files to desplit MUST be in the SAME PATH of splitall!");
				dialogLabel.setText("First file of sequence ");
				sizePanel.setVisible(true);
				if (dialogTextField.getText().trim().equals(""))
					JOptionPane.showMessageDialog(null, "Insert the name of the first file of the splitting-sequence");
				if (lineCommandTextField.getText().equals("") == false)
					lineCommandTextField.setText(lineCommandTextField.getText()+"-m 4 "+" "+dialogSplitting);
				}
			if (V_Button.isSelected())
				{ inTextField.setText("IMPORTANT: files to desplit MUST be in the SAME PATH of splitall!");
				dialogLabel.setText("First file of sequence ");
				sizePanel.setVisible(true);
				if (dialogTextField.getText().trim().equals(""))
					JOptionPane.showMessageDialog(null, "Insert the name of the first file of the splitting-sequence");
				if (lineCommandTextField.getText().equals("") == false)
					lineCommandTextField.setText(lineCommandTextField.getText()+"-m 5 "+" "+dialogSplitting);
				}
			if (VI_Button.isSelected())
				{ inTextField.setText("IMPORTANT: files to desplit MUST be in the SAME PATH of splitall!");
				dialogLabel.setText("First file of sequence ");
				sizePanel.setVisible(true);
				if (dialogTextField.getText().trim().equals(""))
					JOptionPane.showMessageDialog(null, "Insert the name of the first file of the splitting-sequence");
				if (lineCommandTextField.getText().equals("") == false)
					lineCommandTextField.setText(lineCommandTextField.getText()+"-m 6 "+" "+dialogSplitting);
				}
			}
		}
	}

	private class WindowCloser extends WindowAdapter	// killed-frame's interception
	{ public void windowClosing(WindowEvent event)
		{ System.exit(0);
		}
	}
}
